"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const melonjs_1 = require("@melonproject/melonjs");
exports.accounting = ([_, routes], __, context) => {
    if (routes.accounting && !melonjs_1.isZeroAddress(routes.accounting)) {
        return new melonjs_1.Accounting(context.environment, routes.accounting);
    }
    return null;
};
exports.feeManager = ([_, routes], __, context) => {
    if (routes.feeManager && !melonjs_1.isZeroAddress(routes.feeManager)) {
        return new melonjs_1.FeeManager(context.environment, routes.feeManager);
    }
    return null;
};
exports.participation = ([_, routes], __, context) => {
    if (routes.participation && !melonjs_1.isZeroAddress(routes.participation)) {
        return new melonjs_1.Participation(context.environment, routes.participation);
    }
    return null;
};
exports.policyManager = ([_, routes], __, context) => {
    if (routes.policyManager && !melonjs_1.isZeroAddress(routes.policyManager)) {
        return new melonjs_1.PolicyManager(context.environment, routes.policyManager);
    }
    return null;
};
exports.shares = ([_, routes], __, context) => {
    if (routes.shares && !melonjs_1.isZeroAddress(routes.shares)) {
        return new melonjs_1.Shares(context.environment, routes.shares);
    }
    return null;
};
exports.trading = ([_, routes], __, context) => {
    if (routes.accounting && !melonjs_1.isZeroAddress(routes.accounting)) {
        return [routes, new melonjs_1.Trading(context.environment, routes.trading)];
    }
    return null;
};
exports.vault = ([_, routes], __, context) => {
    if (routes.vault && !melonjs_1.isZeroAddress(routes.vault)) {
        return new melonjs_1.Vault(context.environment, routes.vault);
    }
    return null;
};
exports.registry = ([hub], __, context) => __awaiter(void 0, void 0, void 0, function* () {
    const address = yield hub.getRegistry(context.block);
    if (address && !melonjs_1.isZeroAddress(address)) {
        return new melonjs_1.Registry(context.environment, address);
    }
    return null;
});
exports.version = ([hub], __, context) => __awaiter(void 0, void 0, void 0, function* () {
    const address = yield hub.getVersion(context.block);
    if (address && !melonjs_1.isZeroAddress(address)) {
        return new melonjs_1.Version(context.environment, address);
    }
    return null;
});
