"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const melonjs_1 = require("@melonproject/melonjs");
const bignumber_js_1 = __importDefault(require("bignumber.js"));
exports.address = feeManager => feeManager.contract.address;
exports.managementFeeAmount = (feeManager, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        return yield feeManager.getManagementFeeAmount(context.block);
    }
    catch (e) {
        return new bignumber_js_1.default('NaN');
    }
});
exports.performanceFeeAmount = (feeManager, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        return yield feeManager.getPerformanceFeeAmount(context.block);
    }
    catch (e) {
        return new bignumber_js_1.default('NaN');
    }
});
exports.performanceFee = (feeManager, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const address = yield feeManager.getPerformanceFeeAddress(context.block);
    if (address && !melonjs_1.isZeroAddress(address)) {
        return [feeManager, new melonjs_1.PerformanceFee(context.environment, address)];
    }
    return null;
});
exports.managementFee = (feeManager, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const address = yield feeManager.getManagementFeeAddress(context.block);
    if (address && !melonjs_1.isZeroAddress(address)) {
        return [feeManager, new melonjs_1.ManagementFee(context.environment, address)];
    }
    return null;
});
