"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const melonjs_1 = require("@melonproject/melonjs");
function priceFeedContract(environment) {
    const addresses = environment.deployment.melon.addr;
    if (addresses.TestingPriceFeed) {
        return new melonjs_1.KyberPriceFeed(environment, addresses.TestingPriceFeed);
    }
    if (addresses.KyberPriceFeed) {
        return new melonjs_1.KyberPriceFeed(environment, addresses.KyberPriceFeed);
    }
    throw new Error('Missing price feed address');
}
exports.priceFeedContract = priceFeedContract;
function versionContract(environment) {
    return new melonjs_1.Version(environment, environment.deployment.melon.addr.Version);
}
exports.versionContract = versionContract;
function engineContract(environment) {
    return new melonjs_1.Engine(environment, environment.deployment.melon.addr.Engine);
}
exports.engineContract = engineContract;
function registryContract(environment) {
    return new melonjs_1.Registry(environment, environment.deployment.melon.addr.Registry);
}
exports.registryContract = registryContract;
